> ## Documentation Index
> Fetch the complete documentation index at: https://docs.controlplane.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create an Mk8s Cluster



## OpenAPI

````yaml post /org/{org}/mk8s
openapi: 3.0.3
info:
  title: Control Plane Core API
  description: Copyright © 2023 Control Plane Corporation. All rights reserved.
  version: 1.0.0
servers:
  - url: https://api.cpln.io
    description: ''
security:
  - {}
  - serviceAccountKey: []
  - jwt: []
externalDocs:
  url: https://docs.controlplane.com/
  description: End-user documentation
paths:
  /org/{org}/mk8s:
    post:
      tags:
        - mk8s
      summary: Create an Mk8s Cluster
      parameters:
        - in: path
          name: org
          required: true
          schema:
            type: string
      requestBody:
        description: ''
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/mk8s_cluster'
      responses:
        '201':
          description: Mk8s Cluster was created successfully
          content:
            application/json: {}
          headers:
            Location:
              description: Link to the new mk8s cluster
              schema:
                type: string
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error'
        '403':
          description: Access denied
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/error'
components:
  schemas:
    mk8s_cluster:
      type: object
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
          maxLength: 64
        kind:
          type: string
          readOnly: true
        version:
          type: integer
          readOnly: true
        description:
          type: string
          maxLength: 250
        tags:
          type: object
        created:
          type: string
          format: date-time
          readOnly: true
        lastModified:
          type: string
          format: date-time
          readOnly: true
        links:
          type: array
          items:
            $ref: '#/components/schemas/link'
          readOnly: true
        spec:
          type: object
          properties:
            version:
              type: string
              enum:
                - 1.26.0
                - 1.26.4
                - 1.27.3
                - 1.28.2
                - 1.28.4
                - 1.29.7
                - 1.30.3
                - 1.31.5
                - 1.31.13
                - 1.32.1
                - 1.32.9
                - 1.33.5
                - 1.34.2
                - 1.35.3
            firewall:
              type: array
              items:
                type: object
                properties:
                  sourceCIDR:
                    type: string
                  description:
                    type: string
                additionalProperties: false
              description: Allow-list
            provider:
              type: object
              properties:
                generic:
                  type: object
                  properties:
                    location:
                      type: string
                      enum:
                        - aws-eu-central-1
                        - aws-us-east-2
                        - aws-us-west-2
                        - gcp-me-west1
                        - gcp-us-east1
                      description: >-
                        Control Plane location that will host the K8S
                        components. Prefer one that is closest to where the
                        nodes are runnin
                    networking:
                      type: object
                      properties:
                        serviceNetwork:
                          type: string
                          enum:
                            - 10.43.0.0/16
                            - 192.168.0.0/16
                          default: 10.43.0.0/16
                          description: The CIDR of the service network
                        podNetwork:
                          type: string
                          enum:
                            - 10.42.0.0/16
                            - 172.16.0.0/15
                            - 172.18.0.0/15
                            - 172.20.0.0/15
                            - 172.22.0.0/15
                            - 172.24.0.0/15
                            - 172.26.0.0/15
                            - 172.28.0.0/15
                            - 172.30.0.0/15
                          default: 10.42.0.0/16
                          description: The CIDR of the pod network
                        dnsForwarder:
                          type: string
                          maxLength: 100
                          description: >-
                            DNS forwarder used by the cluster. Can be a
                            space-delimited list of dns servers. Default is
                            /etc/resolv.conf when not specified.
                      additionalProperties: false
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                        additionalProperties: false
                  additionalProperties: false
                hetzner:
                  type: object
                  properties:
                    region:
                      type: string
                      enum:
                        - fsn1
                        - nbg1
                        - hel1
                        - ash
                        - hil
                      description: Hetzner region to deploy nodes to
                    hetznerLabels:
                      type: object
                      description: Extra labels to attach to servers
                    networking:
                      type: object
                      properties:
                        serviceNetwork:
                          type: string
                          enum:
                            - 10.43.0.0/16
                            - 192.168.0.0/16
                          default: 10.43.0.0/16
                          readOnly: true
                        podNetwork:
                          type: string
                          enum:
                            - 10.42.0.0/16
                            - 172.16.0.0/15
                            - 172.18.0.0/15
                            - 172.20.0.0/15
                            - 172.22.0.0/15
                            - 172.24.0.0/15
                            - 172.26.0.0/15
                            - 172.28.0.0/15
                            - 172.30.0.0/15
                          default: 10.42.0.0/16
                          readOnly: true
                        dnsForwarder:
                          type: string
                          maxLength: 100
                          description: >-
                            DNS forwarder used by the cluster. Can be a
                            space-delimited list of dns servers. Default is
                            /etc/resolv.conf when not specified.
                      additionalProperties: false
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed
                    tokenSecretLink:
                      type: string
                      description: Link to a secret holding Hetzner access key
                    networkId:
                      type: string
                      description: ID of the Hetzner network to deploy nodes to
                    firewallId:
                      type: string
                      description: Optional firewall rule to attach to all nodes
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          serverType:
                            type: string
                          overrideImage:
                            type: string
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                        additionalProperties: false
                      description: List of node pools
                    dedicatedServerNodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                        additionalProperties: false
                      description: Node pools that can configure dedicated Hetzner servers
                    image:
                      type: string
                      default: ubuntu-20.04
                      description: Default image for all nodes
                    sshKey:
                      type: string
                      description: SSH key name for accessing deployed nodes
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                    floatingIPSelector:
                      type: object
                      description: >-
                        If supplied, nodes will get assigned a random floating
                        ip matching the selector
                  additionalProperties: false
                aws:
                  type: object
                  properties:
                    region:
                      type: string
                      enum:
                        - af-south-1
                        - ap-east-1
                        - ap-northeast-1
                        - ap-northeast-2
                        - ap-northeast-3
                        - ap-south-1
                        - ap-south-2
                        - ap-southeast-1
                        - ap-southeast-2
                        - ap-southeast-3
                        - ap-southeast-4
                        - ca-central-1
                        - eu-central-1
                        - eu-central-2
                        - eu-north-1
                        - eu-south-1
                        - eu-south-2
                        - eu-west-1
                        - eu-west-2
                        - eu-west-3
                        - me-central-1
                        - me-south-1
                        - sa-east-1
                        - us-east-1
                        - us-east-2
                        - us-west-1
                        - us-west-2
                      description: Region where the cluster nodes will live
                    awsTags:
                      type: object
                      description: Extra tags to attach to all created objects
                    skipCreateRoles:
                      type: boolean
                      description: If true, Control Plane will not create any roles
                    networking:
                      type: object
                      properties:
                        serviceNetwork:
                          type: string
                          enum:
                            - 10.43.0.0/16
                            - 192.168.0.0/16
                          default: 10.43.0.0/16
                        podNetwork:
                          type: string
                          enum:
                            - vpc
                            - 10.42.0.0/16
                            - 172.16.0.0/15
                            - 172.18.0.0/15
                            - 172.20.0.0/15
                            - 172.22.0.0/15
                            - 172.24.0.0/15
                            - 172.26.0.0/15
                            - 172.28.0.0/15
                            - 172.30.0.0/15
                          default: 10.42.0.0/16
                        dnsForwarder:
                          type: string
                          maxLength: 100
                          description: >-
                            DNS forwarder used by the cluster. Can be a
                            space-delimited list of dns servers. Default is
                            /etc/resolv.conf when not specified.
                      additionalProperties: false
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed. Supports SSM
                    image:
                      type: object
                      properties:
                        recommended:
                          type: string
                          enum:
                            - ubuntu/jammy-22.04
                            - ubuntu/jammy-22.04+nvidia
                            - ubuntu/focal-20.04
                            - ubuntu/focal-20.04+nvidia
                            - ubuntu/noble-24.04
                            - ubuntu/noble-24.04+nvidia
                            - ubuntu/bionic-18.04
                            - amazon/amzn2
                            - amazon/al2023
                        exact:
                          type: string
                          description: Support SSM
                      additionalProperties: false
                      description: Default image for all nodes.
                    deployRoleArn:
                      type: string
                      description: >-
                        Control Plane will set up the cluster by assuming this
                        role
                    deployRoleChain:
                      type: array
                      items:
                        type: object
                        properties:
                          roleArn:
                            type: string
                          externalId:
                            type: string
                          sessionNamePrefix:
                            type: string
                            maxLength: 50
                            description: Control Plane will append random
                        additionalProperties: false
                    vpcId:
                      type: string
                      description: The vpc where nodes will be deployed. Supports SSM.
                    keyPair:
                      type: string
                      description: Name of keyPair. Supports SSM
                    diskEncryptionKeyArn:
                      type: string
                      description: KMS key used to encrypt volumes. Supports SSM.
                    securityGroupIds:
                      type: array
                      items:
                        type: string
                        description: Supports SSM.
                      description: >-
                        Security groups to deploy nodes to. Security groups
                        control if the cluster is multi-zone or single-zon
                    extraNodePolicies:
                      type: array
                      items:
                        type: string
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          instanceTypes:
                            type: array
                            items:
                              type: string
                          overrideImage:
                            type: object
                            properties:
                              recommended:
                                type: string
                                enum:
                                  - ubuntu/jammy-22.04
                                  - ubuntu/jammy-22.04+nvidia
                                  - ubuntu/focal-20.04
                                  - ubuntu/focal-20.04+nvidia
                                  - ubuntu/noble-24.04
                                  - ubuntu/noble-24.04+nvidia
                                  - ubuntu/bionic-18.04
                                  - amazon/amzn2
                                  - amazon/al2023
                              exact:
                                type: string
                                description: Support SSM
                            additionalProperties: false
                          bootDiskSize:
                            type: integer
                            description: size in GB
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                          onDemandBaseCapacity:
                            type: integer
                          onDemandPercentageAboveBaseCapacity:
                            type: integer
                          spotAllocationStrategy:
                            type: string
                            enum:
                              - lowest-price
                              - capacity-optimized
                              - capacity-optimized-prioritized
                              - price-capacity-optimized
                            default: lowest-price
                          subnetIds:
                            type: array
                            items:
                              type: string
                              description: Supports SSM.
                          extraSecurityGroupIds:
                            type: array
                            items:
                              type: string
                              description: Supports SSM.
                          cpuOptions:
                            type: object
                            properties:
                              nestedVirtualization:
                                type: boolean
                                description: >-
                                  Enable nested virtualization. Only supported
                                  on 8th generation Intel instance types (c8i,
                                  m8i, r8i and variants).
                            additionalProperties: false
                            description: CPU options for the node pool instances.
                        additionalProperties: false
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                  additionalProperties: false
                linode:
                  type: object
                  properties:
                    region:
                      type: string
                    tokenSecretLink:
                      type: string
                    firewallId:
                      type: string
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          serverType:
                            type: string
                          overrideImage:
                            type: string
                          subnetId:
                            type: string
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                        additionalProperties: false
                    image:
                      type: string
                    authorizedUsers:
                      type: array
                      items:
                        type: string
                    authorizedKeys:
                      type: array
                      items:
                        type: string
                    vpcId:
                      type: string
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed
                    networking:
                      type: object
                      properties:
                        serviceNetwork:
                          type: string
                          enum:
                            - 10.43.0.0/16
                            - 192.168.0.0/16
                          default: 10.43.0.0/16
                          readOnly: true
                        podNetwork:
                          type: string
                          enum:
                            - 10.42.0.0/16
                            - 172.16.0.0/15
                            - 172.18.0.0/15
                            - 172.20.0.0/15
                            - 172.22.0.0/15
                            - 172.24.0.0/15
                            - 172.26.0.0/15
                            - 172.28.0.0/15
                            - 172.30.0.0/15
                          default: 10.42.0.0/16
                          readOnly: true
                        dnsForwarder:
                          type: string
                          maxLength: 100
                          description: >-
                            DNS forwarder used by the cluster. Can be a
                            space-delimited list of dns servers. Default is
                            /etc/resolv.conf when not specified.
                      additionalProperties: false
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                  additionalProperties: false
                oblivus:
                  type: object
                  properties:
                    datacenter:
                      type: string
                      enum:
                        - MON1
                        - OSL1
                    tokenSecretLink:
                      type: string
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                          flavor:
                            type: string
                            enum:
                              - A100_NVLINK_80GB_x8
                              - A100_PCIE_80GB_x1
                              - A100_PCIE_80GB_x2
                              - A100_PCIE_80GB_x4
                              - A100_PCIE_80GB_x8
                              - H100_NVLINK_80GB_x8
                              - H100_PCIE_80GB_x1
                              - H100_PCIE_80GB_x2
                              - H100_PCIE_80GB_x4
                              - H100_PCIE_80GB_x8
                              - INTEL_XEON_V3_x16
                              - INTEL_XEON_V3_x4
                              - INTEL_XEON_V3_x8
                              - L40_x1
                              - L40_x2
                              - L40_x4
                              - L40_x8
                              - RTX_A4000_x1
                              - RTX_A4000_x2
                              - RTX_A4000_x4
                              - RTX_A4000_x8
                              - RTX_A5000_x1
                              - RTX_A5000_x2
                              - RTX_A5000_x4
                              - RTX_A5000_x8
                              - RTX_A6000_x1
                              - RTX_A6000_x2
                              - RTX_A6000_x4
                              - RTX_A6000_x8
                        additionalProperties: false
                    sshKeys:
                      type: array
                      items:
                        type: string
                    unmanagedNodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                        additionalProperties: false
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed
                  additionalProperties: false
                lambdalabs:
                  type: object
                  properties:
                    region:
                      type: string
                      enum:
                        - asia-northeast-1
                        - asia-northeast-2
                        - asia-south-1
                        - australia-southeast-1
                        - europe-central-1
                        - europe-south-1
                        - me-west-1
                        - us-east-1
                        - us-midwest-1
                        - us-south-1
                        - us-west-1
                        - us-west-2
                        - us-west-3
                    tokenSecretLink:
                      type: string
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                          instanceType:
                            type: string
                            enum:
                              - cpu_4x_general
                              - gpu_1x_a10
                              - gpu_1x_a100
                              - gpu_1x_a100_sxm4
                              - gpu_1x_a6000
                              - gpu_1x_h100_pcie
                              - gpu_1x_rtx6000
                              - gpu_2x_a100
                              - gpu_2x_a6000
                              - gpu_4x_a100
                              - gpu_4x_a6000
                              - gpu_8x_a100
                              - gpu_8x_a100_80gb_sxm4
                              - gpu_8x_h100_sxm5
                              - gpu_8x_v100
                        additionalProperties: false
                    sshKey:
                      type: string
                    unmanagedNodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                        additionalProperties: false
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                    fileSystems:
                      type: array
                      items:
                        type: string
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed
                  additionalProperties: false
                paperspace:
                  type: object
                  properties:
                    region:
                      type: string
                      enum:
                        - AMS1
                        - NY2
                        - CA1
                    tokenSecretLink:
                      type: string
                    sharedDrives:
                      type: array
                      items:
                        type: string
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                          publicIpType:
                            type: string
                            enum:
                              - none
                              - dynamic
                              - static
                          bootDiskSize:
                            type: integer
                          machineType:
                            type: string
                            enum:
                              - A100
                              - A100-80G
                              - A100-80Gx2
                              - A100-80Gx4
                              - A100-80Gx8
                              - A100x2
                              - A100x4
                              - A100x8
                              - A4000
                              - A4000x2
                              - A4000x4
                              - A5000
                              - A5000x2
                              - A5000x4
                              - A6000
                              - A6000x2
                              - A6000x4
                              - C10
                              - C2
                              - C3
                              - C4
                              - C5
                              - C6
                              - C7
                              - C8
                              - C9
                              - GPU+
                              - P4000
                              - P4000x2
                              - P4000x4
                              - P5000
                              - P5000x2
                              - P6000
                              - P6000x2
                              - RTX4000
                              - RTX5000
                              - RTX5000x2
                              - V100
                              - V100-32G
                              - V100-32Gx2
                              - V100-32Gx4
                        additionalProperties: false
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                    unmanagedNodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                        additionalProperties: false
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed
                    userIds:
                      type: array
                      items:
                        type: string
                    networkId:
                      type: string
                  additionalProperties: false
                ephemeral:
                  type: object
                  properties:
                    location:
                      type: string
                      enum:
                        - aws-eu-central-1
                        - aws-us-east-2
                        - aws-us-west-2
                        - gcp-me-west1
                        - gcp-us-east1
                      description: >-
                        Control Plane location that will host the K8S
                        components. Prefer one that is closest to where the
                        nodes are runnin
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          count:
                            type: integer
                            description: Number of nodes to deploy
                          arch:
                            type: string
                            enum:
                              - any
                              - arm64
                              - amd64
                            description: CPU architecture of the nodes
                          flavor:
                            type: string
                            enum:
                              - debian
                              - ubuntu
                              - fedora
                            default: debian
                            description: Linux distro to use for ephemeral nodes
                          cpu:
                            type: string
                            maxLength: 20
                            description: Allocated CPU
                          memory:
                            type: string
                            maxLength: 20
                            description: Allocated memory
                        additionalProperties: false
                  additionalProperties: false
                triton:
                  type: object
                  properties:
                    connection:
                      type: object
                      properties:
                        url:
                          type: string
                        account:
                          type: string
                        user:
                          type: string
                        privateKeySecretLink:
                          type: string
                          description: Link to a ssh or opaque secret
                      additionalProperties: false
                    networking:
                      type: object
                      properties:
                        serviceNetwork:
                          type: string
                          enum:
                            - 10.43.0.0/16
                            - 192.168.0.0/16
                          default: 10.43.0.0/16
                          readOnly: true
                        podNetwork:
                          type: string
                          enum:
                            - 10.42.0.0/16
                            - 172.16.0.0/15
                            - 172.18.0.0/15
                            - 172.20.0.0/15
                            - 172.22.0.0/15
                            - 172.24.0.0/15
                            - 172.26.0.0/15
                            - 172.28.0.0/15
                            - 172.30.0.0/15
                          default: 10.42.0.0/16
                          readOnly: true
                        dnsForwarder:
                          type: string
                          maxLength: 100
                          description: >-
                            DNS forwarder used by the cluster. Can be a
                            space-delimited list of dns servers. Default is
                            /etc/resolv.conf when not specified.
                      additionalProperties: false
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed
                    location:
                      type: string
                      enum:
                        - aws-eu-central-1
                        - aws-us-east-2
                        - aws-us-west-2
                        - gcp-me-west1
                        - gcp-us-east1
                      description: >-
                        Control Plane location that will host the K8S
                        components. Prefer one that is closest to the Triton
                        datacenter
                    loadBalancer:
                      type: object
                      properties:
                        manual:
                          type: object
                          properties:
                            packageId:
                              type: string
                            imageId:
                              type: string
                            publicNetworkId:
                              type: string
                              description: If set, machine will also get a public IP
                            privateNetworkIds:
                              type: array
                              items:
                                type: string
                              description: More private networks to join
                            metadata:
                              type: object
                              description: >-
                                Extra tags to attach to instances from a node
                                pool
                            tags:
                              type: object
                              description: >-
                                Extra tags to attach to instances from a node
                                pool
                            logging:
                              type: object
                              properties:
                                nodePort:
                                  type: integer
                                externalSyslog:
                                  type: string
                              additionalProperties: false
                            count:
                              type: integer
                            cnsInternalDomain:
                              type: string
                            cnsPublicDomain:
                              type: string
                          additionalProperties: false
                        none:
                          type: object
                        gateway:
                          type: object
                      additionalProperties: false
                    privateNetworkId:
                      type: string
                      description: ID of the private Fabric/Network
                    firewallEnabled:
                      type: boolean
                      description: Enable firewall for the instances deployed
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          packageId:
                            type: string
                          overrideImageId:
                            type: string
                          publicNetworkId:
                            type: string
                            description: If set, machine will also get a public IP
                          privateNetworkIds:
                            type: array
                            items:
                              type: string
                            description: More private networks to join
                          tritonTags:
                            type: object
                            description: Extra tags to attach to instances from a node pool
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                        additionalProperties: false
                      description: List of node pools
                    imageId:
                      type: string
                      description: Default image for all nodes
                    sshKeys:
                      type: array
                      items:
                        type: string
                      description: Extra SSH keys to provision for user root
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                  additionalProperties: false
                azure:
                  type: object
                  properties:
                    location:
                      type: string
                      description: Region where the cluster nodes will live
                    subscriptionId:
                      type: string
                    sdkSecretLink:
                      type: string
                      description: Link to an opaque secret
                    resourceGroup:
                      type: string
                    networking:
                      type: object
                      properties:
                        serviceNetwork:
                          type: string
                          enum:
                            - 10.43.0.0/16
                            - 192.168.0.0/16
                          default: 10.43.0.0/16
                        podNetwork:
                          type: string
                          enum:
                            - 10.42.0.0/16
                            - 172.16.0.0/15
                            - 172.18.0.0/15
                            - 172.20.0.0/15
                            - 172.22.0.0/15
                            - 172.24.0.0/15
                            - 172.26.0.0/15
                            - 172.28.0.0/15
                            - 172.30.0.0/15
                          default: 10.42.0.0/16
                        dnsForwarder:
                          type: string
                          maxLength: 100
                          description: >-
                            DNS forwarder used by the cluster. Can be a
                            space-delimited list of dns servers. Default is
                            /etc/resolv.conf when not specified.
                      additionalProperties: false
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed. Supports SSM
                    image:
                      type: object
                      properties:
                        recommended:
                          type: string
                          enum:
                            - ubuntu/noble-24.04
                            - ubuntu/jammy-22.04
                            - ubuntu/focal-20.04
                            - debian/bookworm-12
                            - debian/bullseye-11
                        reference:
                          type: object
                          properties:
                            publisher:
                              type: string
                            offer:
                              type: string
                            sku:
                              type: string
                            version:
                              type: string
                          additionalProperties: false
                      additionalProperties: false
                      description: Default image for all nodes.
                    sshKeys:
                      type: array
                      items:
                        type: string
                      description: SSH keys to install for "azureuser" linux user
                    networkId:
                      type: string
                      description: The vpc where nodes will be deployed.
                    tags:
                      type: object
                      description: Extra tags to attach to all created objects
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          size:
                            type: string
                          subnetId:
                            type: string
                          zones:
                            type: array
                            items:
                              type: number
                          overrideImage:
                            type: object
                            properties:
                              recommended:
                                type: string
                                enum:
                                  - ubuntu/noble-24.04
                                  - ubuntu/jammy-22.04
                                  - ubuntu/focal-20.04
                                  - debian/bookworm-12
                                  - debian/bullseye-11
                              reference:
                                type: object
                                properties:
                                  publisher:
                                    type: string
                                  offer:
                                    type: string
                                  sku:
                                    type: string
                                  version:
                                    type: string
                                additionalProperties: false
                            additionalProperties: false
                          bootDiskSize:
                            type: integer
                            description: size in GB
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                        additionalProperties: false
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                  additionalProperties: false
                digitalocean:
                  type: object
                  properties:
                    region:
                      type: string
                      enum:
                        - ams3
                        - blr1
                        - fra1
                        - lon1
                        - nyc1
                        - nyc2
                        - nyc3
                        - sfo2
                        - sfo3
                        - sgp1
                        - syd1
                        - tor1
                      description: Region to deploy nodes to
                    digitalOceanTags:
                      type: array
                      items:
                        type: string
                        maxLength: 254
                      description: Extra tags to attach to droplets
                    networking:
                      type: object
                      properties:
                        serviceNetwork:
                          type: string
                          enum:
                            - 10.43.0.0/16
                            - 192.168.0.0/16
                          default: 10.43.0.0/16
                          readOnly: true
                        podNetwork:
                          type: string
                          enum:
                            - 10.42.0.0/16
                            - 172.16.0.0/15
                            - 172.18.0.0/15
                            - 172.20.0.0/15
                            - 172.22.0.0/15
                            - 172.24.0.0/15
                            - 172.26.0.0/15
                            - 172.28.0.0/15
                            - 172.30.0.0/15
                          default: 10.42.0.0/16
                          readOnly: true
                        dnsForwarder:
                          type: string
                          maxLength: 100
                          description: >-
                            DNS forwarder used by the cluster. Can be a
                            space-delimited list of dns servers. Default is
                            /etc/resolv.conf when not specified.
                      additionalProperties: false
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed
                    tokenSecretLink:
                      type: string
                      description: Link to a secret holding personal access token
                    vpcId:
                      type: string
                      description: ID of the Hetzner network to deploy nodes to
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          dropletSize:
                            type: string
                          overrideImage:
                            type: string
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                        additionalProperties: false
                      description: List of node pools
                    image:
                      type: string
                      description: Default image for all nodes
                    sshKeys:
                      type: array
                      items:
                        type: string
                      description: SSH key name for accessing deployed nodes
                    extraSshKeys:
                      type: array
                      items:
                        type: string
                      description: >-
                        Extra SSH keys to provision for user root that are not
                        registered in the DigitalOcean
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                    reservedIPs:
                      type: array
                      items:
                        type: string
                      description: >-
                        Optional set of IPs to assign as extra IPs for nodes of
                        the cluster
                  additionalProperties: false
                gcp:
                  type: object
                  properties:
                    projectId:
                      type: string
                    region:
                      type: string
                      description: Region where the cluster nodes will live
                    labels:
                      type: object
                      description: Extra tags to attach to all created objects
                    tags:
                      type: array
                      items:
                        type: string
                        maxLength: 63
                    metadata:
                      type: object
                    network:
                      type: string
                    saKeyLink:
                      type: string
                      description: Link to a GCP secret containing the SA json key
                    networking:
                      type: object
                      properties:
                        serviceNetwork:
                          type: string
                          enum:
                            - 10.43.0.0/16
                            - 192.168.0.0/16
                          default: 10.43.0.0/16
                        podNetwork:
                          type: string
                          enum:
                            - vpc
                            - 10.42.0.0/16
                            - 172.16.0.0/15
                            - 172.18.0.0/15
                            - 172.20.0.0/15
                            - 172.22.0.0/15
                            - 172.24.0.0/15
                            - 172.26.0.0/15
                            - 172.28.0.0/15
                            - 172.30.0.0/15
                          default: 10.42.0.0/16
                        dnsForwarder:
                          type: string
                          maxLength: 100
                          description: >-
                            DNS forwarder used by the cluster. Can be a
                            space-delimited list of dns servers. Default is
                            /etc/resolv.conf when not specified.
                      additionalProperties: false
                    preInstallScript:
                      type: string
                      description: >-
                        Optional shell script that will be run before K8S is
                        installed
                    image:
                      type: object
                      properties:
                        recommended:
                          type: string
                          enum:
                            - ubuntu/jammy-22.04
                            - ubuntu/noble-24.04
                            - debian/bookworm-12
                            - debian/trixie-13
                            - google/cos-stable
                        family:
                          type: object
                          properties:
                            project:
                              type: string
                            family:
                              type: string
                          additionalProperties: false
                        exact:
                          type: string
                      additionalProperties: false
                      description: Default image for all nodes.
                    nodePools:
                      type: array
                      items:
                        type: object
                        properties:
                          name:
                            type: string
                            maxLength: 63
                          labels:
                            type: object
                            description: Labels to attach to nodes of a node pool
                          taints:
                            type: array
                            items:
                              type: object
                              properties:
                                key:
                                  type: string
                                value:
                                  type: string
                                effect:
                                  type: string
                                  enum:
                                    - NoSchedule
                                    - PreferNoSchedule
                                    - NoExecute
                              additionalProperties: false
                            description: Taints for the nodes of a pool
                          machineType:
                            type: string
                          assignPublicIP:
                            type: boolean
                          zone:
                            type: string
                          overrideImage:
                            type: object
                            properties:
                              recommended:
                                type: string
                                enum:
                                  - ubuntu/jammy-22.04
                                  - ubuntu/noble-24.04
                                  - debian/bookworm-12
                                  - debian/trixie-13
                                  - google/cos-stable
                              family:
                                type: object
                                properties:
                                  project:
                                    type: string
                                  family:
                                    type: string
                                additionalProperties: false
                              exact:
                                type: string
                            additionalProperties: false
                          bootDiskSize:
                            type: integer
                            description: size in GB
                          minSize:
                            type: integer
                          maxSize:
                            type: integer
                          preemptible:
                            type: boolean
                          subnet:
                            type: string
                          localPersistentDisks:
                            type: integer
                        additionalProperties: false
                    autoscaler:
                      type: object
                      properties:
                        expander:
                          type: array
                          items:
                            type: string
                            enum:
                              - random
                              - most-pods
                              - least-waste
                              - price
                        unneededTime:
                          type: string
                          default: 10m
                        unreadyTime:
                          type: string
                          default: 20m
                        utilizationThreshold:
                          type: number
                      additionalProperties: false
                  additionalProperties: false
              additionalProperties: false
            addOns:
              type: object
              properties:
                dashboard:
                  type: object
                  properties: {}
                  additionalProperties: false
                headlamp:
                  type: object
                  properties: {}
                  additionalProperties: false
                azureWorkloadIdentity:
                  type: object
                  properties:
                    tenantId:
                      type: string
                      description: Tenant ID to use for workload identity
                  additionalProperties: false
                awsWorkloadIdentity:
                  type: object
                  properties: {}
                  additionalProperties: false
                localPathStorage:
                  type: object
                  properties: {}
                  additionalProperties: false
                metrics:
                  type: object
                  properties:
                    kubeState:
                      type: boolean
                      description: Enable kube-state metrics
                    coreDns:
                      type: boolean
                      description: Enable scraping of core-dns service
                    kubelet:
                      type: boolean
                      description: Enable scraping kubelet stats
                    apiserver:
                      type: boolean
                      description: Enable scraping apiserver stats
                    nodeExporter:
                      type: boolean
                      description: >-
                        Enable collecting node-level stats (disk, network,
                        filesystem, etc)
                    cadvisor:
                      type: boolean
                      description: Enable CNI-level container stats
                    scrapeAnnotated:
                      type: object
                      properties:
                        intervalSeconds:
                          type: integer
                        includeNamespaces:
                          type: string
                        excludeNamespaces:
                          type: string
                        retainLabels:
                          type: string
                      additionalProperties: false
                      description: Scrape pods annotated with prometheus.io/scrape=true
                  additionalProperties: false
                logs:
                  type: object
                  properties:
                    auditEnabled:
                      type: boolean
                      description: 'Collect k8s audit log as log events '
                    includeNamespaces:
                      type: string
                    excludeNamespaces:
                      type: string
                    docker:
                      type: boolean
                      description: Collect docker logs if docker is also running
                    kubelet:
                      type: boolean
                      description: Collect kubelet logs from journald
                    kernel:
                      type: boolean
                      description: Collect kernel logs
                    events:
                      type: boolean
                      description: Collect K8S events from all namespaces
                  additionalProperties: false
                registryMirror:
                  type: object
                  properties:
                    mirrors:
                      type: array
                      items:
                        type: object
                        properties:
                          registry:
                            oneOf:
                              - type: string
                              - type: string
                                enum:
                                  - '*'
                          mirrors:
                            type: array
                            items:
                              type: string
                        additionalProperties: false
                  additionalProperties: false
                nvidia:
                  type: object
                  properties:
                    taintGPUNodes:
                      type: boolean
                  additionalProperties: false
                awsEFS:
                  type: object
                  properties:
                    roleArn:
                      type: string
                      description: Use this role for EFS interaction
                  additionalProperties: false
                awsECR:
                  type: object
                  properties:
                    roleArn:
                      type: string
                      description: >-
                        Optional on AWS, in which case it will use the instance
                        role to pull
                  additionalProperties: false
                awsELB:
                  type: object
                  properties:
                    roleArn:
                      type: string
                      description: >-
                        Optional on AWS, when not provided it will create the
                        recommended role
                  additionalProperties: false
                azureACR:
                  type: object
                  properties:
                    clientId:
                      type: string
                  additionalProperties: false
                sysbox:
                  type: object
                  properties: {}
                  additionalProperties: false
                byok:
                  type: object
                  properties:
                    ignoreUpdates:
                      type: boolean
                    location:
                      type: string
                    config:
                      type: object
                      properties:
                        actuator:
                          type: object
                          properties:
                            minCpu:
                              type: string
                              maxLength: 20
                              description: >-
                                CPU allocation specified as millicores (e.g.,
                                50m, 1000m)
                            maxCpu:
                              type: string
                              maxLength: 20
                              description: >-
                                CPU allocation specified as millicores (e.g.,
                                50m, 1000m)
                            minMemory:
                              type: string
                              maxLength: 20
                              description: >-
                                Memory allocation specified as a string with
                                units (e.g., 128Mi, 1Gi, 512M). Supports G, M,
                                k, Gi, Mi, Ki suffixes.
                            maxMemory:
                              type: string
                              maxLength: 20
                              description: >-
                                Memory allocation specified as a string with
                                units (e.g., 128Mi, 1Gi, 512M). Supports G, M,
                                k, Gi, Mi, Ki suffixes.
                            logLevel:
                              type: string
                              enum:
                                - trace
                                - info
                                - error
                            env:
                              type: object
                          additionalProperties: false
                        juicefs:
                          type: object
                          properties:
                            enabled:
                              type: boolean
                          additionalProperties: false
                        middlebox:
                          type: object
                          properties:
                            enabled:
                              type: boolean
                            bandwidthAlertMbps:
                              type: integer
                            ip:
                              type: string
                            ingressReplicas:
                              type: integer
                            port:
                              type: number
                          additionalProperties: false
                        common:
                          type: object
                          properties:
                            deploymentReplicas:
                              type: integer
                            pdb:
                              type: object
                              properties:
                                maxUnavailable:
                                  type: integer
                              additionalProperties: false
                          additionalProperties: false
                        longhorn:
                          type: object
                          properties:
                            numberOfReplicas:
                              type: integer
                            replicas:
                              type: integer
                            isDefault:
                              type: boolean
                          additionalProperties: false
                        byok:
                          type: object
                          properties:
                            noDefaultStorageClasses:
                              type: boolean
                          additionalProperties: false
                        ingress:
                          type: object
                          properties:
                            cpu:
                              type: string
                              maxLength: 20
                              description: >-
                                CPU allocation specified as millicores (e.g.,
                                50m, 1000m)
                            memory:
                              type: string
                              maxLength: 20
                              description: >-
                                Memory allocation specified as a string with
                                units (e.g., 128Mi, 1Gi, 512M). Supports G, M,
                                k, Gi, Mi, Ki suffixes.
                            targetPercent:
                              type: number
                          additionalProperties: false
                        istio:
                          type: object
                          properties:
                            istiod:
                              type: object
                              properties:
                                replicas:
                                  type: integer
                                minCpu:
                                  type: string
                                  maxLength: 20
                                  description: >-
                                    CPU allocation specified as millicores
                                    (e.g., 50m, 1000m)
                                maxCpu:
                                  type: string
                                  maxLength: 20
                                  description: >-
                                    CPU allocation specified as millicores
                                    (e.g., 50m, 1000m)
                                minMemory:
                                  type: string
                                  maxLength: 20
                                  description: >-
                                    Memory allocation specified as a string with
                                    units (e.g., 128Mi, 1Gi, 512M). Supports G,
                                    M, k, Gi, Mi, Ki suffixes.
                                maxMemory:
                                  type: string
                                  maxLength: 20
                                  description: >-
                                    Memory allocation specified as a string with
                                    units (e.g., 128Mi, 1Gi, 512M). Supports G,
                                    M, k, Gi, Mi, Ki suffixes.
                                pdb:
                                  type: integer
                              additionalProperties: false
                            ingressgateway:
                              type: object
                              properties:
                                replicas:
                                  type: integer
                                maxCpu:
                                  type: string
                                  maxLength: 20
                                  description: >-
                                    CPU allocation specified as millicores
                                    (e.g., 50m, 1000m)
                                maxMemory:
                                  type: string
                                  maxLength: 20
                                  description: >-
                                    Memory allocation specified as a string with
                                    units (e.g., 128Mi, 1Gi, 512M). Supports G,
                                    M, k, Gi, Mi, Ki suffixes.
                              additionalProperties: false
                            sidecar:
                              type: object
                              properties:
                                minCpu:
                                  type: string
                                  maxLength: 20
                                  description: >-
                                    CPU allocation specified as millicores
                                    (e.g., 50m, 1000m)
                                minMemory:
                                  type: string
                                  maxLength: 20
                                  description: >-
                                    Memory allocation specified as a string with
                                    units (e.g., 128Mi, 1Gi, 512M). Supports G,
                                    M, k, Gi, Mi, Ki suffixes.
                              additionalProperties: false
                          additionalProperties: false
                        logSplitter:
                          type: object
                          properties:
                            minCpu:
                              type: string
                              maxLength: 20
                              description: >-
                                CPU allocation specified as millicores (e.g.,
                                50m, 1000m)
                            maxCpu:
                              type: string
                              maxLength: 20
                              description: >-
                                CPU allocation specified as millicores (e.g.,
                                50m, 1000m)
                            minMemory:
                              type: string
                              maxLength: 20
                              description: >-
                                Memory allocation specified as a string with
                                units (e.g., 128Mi, 1Gi, 512M). Supports G, M,
                                k, Gi, Mi, Ki suffixes.
                            maxMemory:
                              type: string
                              maxLength: 20
                              description: >-
                                Memory allocation specified as a string with
                                units (e.g., 128Mi, 1Gi, 512M). Supports G, M,
                                k, Gi, Mi, Ki suffixes.
                            memBufferSize:
                              type: string
                            perPodRate:
                              type: integer
                          additionalProperties: false
                        monitoring:
                          type: object
                          properties:
                            minMemory:
                              type: string
                              maxLength: 20
                              description: >-
                                Memory allocation specified as a string with
                                units (e.g., 128Mi, 1Gi, 512M). Supports G, M,
                                k, Gi, Mi, Ki suffixes.
                            maxMemory:
                              type: string
                              maxLength: 20
                              description: >-
                                Memory allocation specified as a string with
                                units (e.g., 128Mi, 1Gi, 512M). Supports G, M,
                                k, Gi, Mi, Ki suffixes.
                            kubeStateMetrics:
                              type: object
                              properties:
                                minMemory:
                                  type: string
                                  maxLength: 20
                                  description: >-
                                    Memory allocation specified as a string with
                                    units (e.g., 128Mi, 1Gi, 512M). Supports G,
                                    M, k, Gi, Mi, Ki suffixes.
                              additionalProperties: false
                            prometheus:
                              type: object
                              properties:
                                main:
                                  type: object
                                  properties:
                                    storage:
                                      type: string
                                      maxLength: 20
                                      description: >-
                                        Memory allocation specified as a string
                                        with units (e.g., 128Mi, 1Gi, 512M).
                                        Supports G, M, k, Gi, Mi, Ki suffixes.
                                  additionalProperties: false
                              additionalProperties: false
                            remoteWrite:
                              type: array
                              items:
                                type: object
                                properties:
                                  basic_auth:
                                    type: object
                                    properties:
                                      username:
                                        type: string
                                      username_file:
                                        type: string
                                      password:
                                        type: string
                                      password_file:
                                        type: string
                                    additionalProperties: false
                                  authorization:
                                    type: object
                                    properties:
                                      type:
                                        type: string
                                      credentials:
                                        type: string
                                      credentials_file:
                                        type: string
                                    additionalProperties: false
                                  oauth2:
                                    type: object
                                  follow_redirects:
                                    type: boolean
                                  enable_http2:
[...]
